using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Chapter2
{
	/// <summary>
	/// Summary description for PaintedForm.
	/// </summary>
	public class PaintedForm : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public PaintedForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.labelInstructions = new System.Windows.Forms.Label();
            this.labelHit = new System.Windows.Forms.Label();
            this.SuspendLayout();
            // 
            // labelInstructions
            // 
            this.labelInstructions.BackColor = System.Drawing.Color.Transparent;
            this.labelInstructions.Location = new System.Drawing.Point(56, 168);
            this.labelInstructions.Name = "labelInstructions";
            this.labelInstructions.Size = new System.Drawing.Size(192, 56);
            this.labelInstructions.TabIndex = 0;
            this.labelInstructions.Text = "Use F1 to test if current mouse is in rectangle. Use mouse click to test if curre" +
                "nt position is also i rectangle.";
            this.labelInstructions.Click += new System.EventHandler(this.labelInstructions_Click);
            // 
            // labelHit
            // 
            this.labelHit.BackColor = System.Drawing.Color.Transparent;
            this.labelHit.Location = new System.Drawing.Point(96, 112);
            this.labelHit.Name = "labelHit";
            this.labelHit.Size = new System.Drawing.Size(104, 32);
            this.labelHit.TabIndex = 1;
            // 
            // PaintedForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(292, 266);
            this.Controls.Add(this.labelHit);
            this.Controls.Add(this.labelInstructions);
            this.HelpButton = true;
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "PaintedForm";
            this.Text = "PaintedForm";
            this.Load += new System.EventHandler(this.PaintedForm_Load);
            this.Paint += new System.Windows.Forms.PaintEventHandler(this.PaintedForm_Paint);
            this.MouseDown += new System.Windows.Forms.MouseEventHandler(this.PaintedForm_MouseDown);
            this.HelpRequested += new System.Windows.Forms.HelpEventHandler(this.PaintedForm_HelpRequested);
            this.ResumeLayout(false);

		}
		#endregion

		private void PaintedForm_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			Graphics g = e.Graphics;
			g.FillEllipse(Brushes.Yellow, this.ClientRectangle);
			g.DrawEllipse(Pens.DarkBlue, this.ClientRectangle);
			g.FillRectangle(Brushes.Red, rectHit);
		}

		private System.Windows.Forms.Label labelInstructions;
		private System.Windows.Forms.Label labelHit;

		Rectangle rectHit = new Rectangle(25,25,25,25);

		private void PaintedForm_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			Region reg = new Region(rectHit);
			if (reg.IsVisible(e.Location)) 
			{
                labelHit.Text = "Mouse Hit " + e.Location;
			} 
			else 
			{
                labelHit.Text = "Mouse Missed " + e.Location;
			}
			
		}

		private void PaintedForm_HelpRequested(object sender, System.Windows.Forms.HelpEventArgs hlpevent)
		{
			Point ptClient = PointToClient(hlpevent.MousePos);            
			Region reg = new Region(rectHit);
            Console.Out.WriteLine("{0}, {1}", hlpevent.MousePos, rectHit);
			if (reg.IsVisible(ptClient)) 
			{
				labelHit.Text = "Help Hit " + hlpevent.MousePos;
			} 
			else 
			{
				labelHit.Text = "Help Missed " + hlpevent.MousePos;
			}
		}

		private void labelInstructions_Click(object sender, System.EventArgs e)
		{
		
		}

		private void PaintedForm_Load(object sender, System.EventArgs e)
		{
			this.MinimumSize = new Size(300,300);
			this.MaximumSize = new Size(400,400);
		}
	}
}
