using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Chapter2
{
	/// <summary>
	/// Summary description for ThemedForm.
	/// </summary>
	public class ThemedForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Button button3;
		private System.Windows.Forms.Button button4;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Label label1;
        private ComboBox comboBoxFlatStyle;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ThemedForm() : this(FlatStyle.Flat) 
		{

		}

		public ThemedForm(FlatStyle style)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//

            foreach (FlatStyle flatStyle in Enum.GetValues(typeof(FlatStyle)))
            {
                comboBoxFlatStyle.Items.Add(flatStyle);
            }
            comboBoxFlatStyle.SelectedItem = style;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.button1 = new System.Windows.Forms.Button();
            this.button2 = new System.Windows.Forms.Button();
            this.button3 = new System.Windows.Forms.Button();
            this.button4 = new System.Windows.Forms.Button();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.label1 = new System.Windows.Forms.Label();
            this.comboBoxFlatStyle = new System.Windows.Forms.ComboBox();
            this.groupBox1.SuspendLayout();
            this.SuspendLayout();
            // 
            // button1
            // 
            this.button1.Location = new System.Drawing.Point(32, 40);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(104, 24);
            this.button1.TabIndex = 0;
            this.button1.Text = "button1";
            // 
            // button2
            // 
            this.button2.Location = new System.Drawing.Point(32, 88);
            this.button2.Name = "button2";
            this.button2.Size = new System.Drawing.Size(104, 24);
            this.button2.TabIndex = 1;
            this.button2.Text = "button2";
            // 
            // button3
            // 
            this.button3.Location = new System.Drawing.Point(24, 32);
            this.button3.Name = "button3";
            this.button3.Size = new System.Drawing.Size(104, 24);
            this.button3.TabIndex = 2;
            this.button3.Text = "button3";
            // 
            // button4
            // 
            this.button4.Location = new System.Drawing.Point(24, 72);
            this.button4.Name = "button4";
            this.button4.Size = new System.Drawing.Size(104, 24);
            this.button4.TabIndex = 3;
            this.button4.Text = "button4";
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.button3);
            this.groupBox1.Controls.Add(this.button4);
            this.groupBox1.Location = new System.Drawing.Point(176, 8);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(144, 120);
            this.groupBox1.TabIndex = 4;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "groupBox1";
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(16, 8);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(144, 24);
            this.label1.TabIndex = 5;
            this.label1.Text = "Fancy Theme";
            // 
            // comboBoxFlatStyle
            // 
            this.comboBoxFlatStyle.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxFlatStyle.FormattingEnabled = true;
            this.comboBoxFlatStyle.Location = new System.Drawing.Point(32, 153);
            this.comboBoxFlatStyle.Name = "comboBoxFlatStyle";
            this.comboBoxFlatStyle.Size = new System.Drawing.Size(121, 21);
            this.comboBoxFlatStyle.TabIndex = 7;
            this.comboBoxFlatStyle.SelectedIndexChanged += new System.EventHandler(this.comboBoxFlatStyle_SelectedIndexChanged);
            // 
            // ThemedForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(336, 283);
            this.Controls.Add(this.comboBoxFlatStyle);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.groupBox1);
            this.Controls.Add(this.button2);
            this.Controls.Add(this.button1);
            this.Name = "ThemedForm";
            this.Text = "ThemedForm";
            this.groupBox1.ResumeLayout(false);
            this.ResumeLayout(false);

		}
		#endregion

		//Loop through the controls that can have a themed style and
		//set FlatStyle to System instead of standard.
		void SetFlatStyleSystem(Control parent, FlatStyle style) 
		{
			foreach( Control control in parent.Controls )
			{
				ButtonBase button = control as ButtonBase;
				GroupBox group = control as GroupBox;
				Label label = control as Label;
                if (button != null) button.FlatStyle = style;
                else if (group != null) group.FlatStyle = style;
                else if (label != null) label.FlatStyle = style;
 
				//Recurse through any container controls.
				SetFlatStyleSystem( control, style );
			}
		}

        private void comboBoxFlatStyle_SelectedIndexChanged(object sender, EventArgs e)
        {
            //String strStyle = (String);
            FlatStyle style = (FlatStyle)comboBoxFlatStyle.SelectedItem;//Enum.Parse(typeof(FlatStyle), strStyle);
            SetFlatStyleSystem(this, style);
        }
	}
}
